/*******************************************************************************
 *    Rubik's Cube 3D game
 *     Copyright (C) 2011  Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com)
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 * 
 * 
 * Contributors:
 * Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com) - Core and UI development
 * Vishwajit Gaikwad (vishrockon7@gmail.com) - Testing
 ******************************************************************************/
package rubik.core;

public class RubikCoordinates {
	
	public static final Integer c0 = 0;
	public static final Integer c1 = 1;
	public static final Integer c2 = 2;
	
	public static final Integer[] c0_0_0 = {c0, c0, c0};
	public static final Integer[] c1_0_0 = {c1, c0, c0};
	public static final Integer[] c2_0_0 = {c2, c0, c0};
	public static final Integer[] c0_1_0 = {c0, c1, c0};
	public static final Integer[] c1_1_0 = {c1, c1, c0};
	public static final Integer[] c2_1_0 = {c2, c1, c0};
	public static final Integer[] c0_2_0 = {c0, c2, c0};
	public static final Integer[] c1_2_0 = {c1, c2, c0};
	public static final Integer[] c2_2_0 = {c2, c2, c0};

	public static final Integer[] c0_0_1 = {c0, c0, c1};
	public static final Integer[] c1_0_1 = {c1, c0, c1};
	public static final Integer[] c2_0_1 = {c2, c0, c1};
	public static final Integer[] c0_1_1 = {c0, c1, c1};
	public static final Integer[] c0_2_1 = {c0, c2, c1};
	public static final Integer[] c1_2_1 = {c1, c2, c1};
	public static final Integer[] c2_2_1 = {c2, c2, c1};
	public static final Integer[] c2_1_1 = {c2, c1, c1};

	public static final Integer[] c0_0_2 = {c0, c0, c2};
	public static final Integer[] c1_0_2 = {c1, c0, c2};
	public static final Integer[] c2_0_2 = {c2, c0, c2};
	public static final Integer[] c0_1_2 = {c0, c1, c2};
	public static final Integer[] c1_1_2 = {c1, c1, c2};
	public static final Integer[] c2_1_2 = {c2, c1, c2};
	public static final Integer[] c0_2_2 = {c0, c2, c2};
	public static final Integer[] c1_2_2 = {c1, c2, c2};
	public static final Integer[] c2_2_2 = {c2, c2, c2};
	
	public static final Integer[][] allCoords = { 
			c0_0_0,  c1_0_0, c2_0_0,
			c0_1_0, c1_1_0, c2_1_0,
			c0_2_0, c1_2_0, c2_2_0,
			c0_0_1, c1_0_1, c2_0_1,
			c0_1_1, c0_2_1, c1_2_1,
			c2_2_1, c2_1_1,
			c0_0_2, c1_0_2, c2_0_2,
			c0_1_2, c1_1_2, c2_1_2,
			c0_2_2, c1_2_2, c2_2_2};
	
	public static final int X_1 = 0;
	public static final int X_2 = 1;
	public static final int X_3 = 2;
	public static final int Y_1 = 3;
	public static final int Y_2 = 4;
	public static final int Y_3 = 5;
	public static final int Z_1 = 6;
	public static final int Z_2 = 7;
	public static final int Z_3 = 8;
	public static final int CW = 9;
	public static final int CCW = 10;

	private Integer x = null;
	private Integer y = null;
	private Integer z = null;
	
	public RubikCoordinates() {
	}

	public RubikCoordinates(Integer Rx, Integer Ry, Integer Rz) {
		x = Rx;
		y = Ry;
		z = Rz;
	}

	public RubikCoordinates(Integer[] COORDS) {
		setCoordinates(COORDS);
	}

	public Integer[] getCoordinates_Iarray() {
		for(int i=0; i<26; i++) {
			if(x == allCoords[i][0] && y == allCoords[i][1] && z == allCoords[i][2]) {
				return allCoords[i];
			}
		}
		return null;
	}

	public int getx() {
		return x;
	}
	
	public int gety() {
		return y;
	}

	public int getz() {
		return z;
	}
	
	public boolean isValid() {
		if(x == 1 && y == 1 && z == 1) {
			return false;
		}
		else if(x > 2 || x < 0 ||
				y > 2 || y < 0 ||
				z > 2 || z < 0) {
			return false;
		}
		else {
			return true;
		}
	}
	
	public void setCoordinates(Integer Rx, Integer Ry, Integer Rz) {
		x = Rx;
		y = Ry;
		z = Rz;
	}
	
	public void setCoordinates(Integer[] COORDS) {
		x = COORDS[0];
		y = COORDS[1];
		z = COORDS[2];
}

}
