package rubik.core;

import java.util.HashMap;
import java.util.Map;

public class RubikListReductionMaps {
	
	static Map<Integer, Integer> e5c5 = null;
	static Map<Integer, Integer> e3c3 = null;
	static Map<Integer, Integer> r5v5 = null;
	static Map<Integer, Integer> r3v3 = null;
	static Map<Integer, Integer> t5b5 = null;
	static Map<Integer, Integer> t3b3 = null;
	
	public static Map<Integer, Integer> gete5c5Map() {
		if(e5c5 == null) {
			
			e5c5 = new HashMap<Integer, Integer>();
			
			e5c5.put(RubikRotationList.e3, RubikRotationList.e3);
			e5c5.put(RubikRotationList.d3, RubikRotationList.d3);
			e5c5.put(RubikRotationList.c3, RubikRotationList.c3);
			e5c5.put(RubikRotationList.e5, RubikRotationList.e5);
			e5c5.put(RubikRotationList.d5, RubikRotationList.d5);
			e5c5.put(RubikRotationList.c5, RubikRotationList.c5);
			e5c5.put(RubikRotationList.r3, RubikRotationList.t3);
			e5c5.put(RubikRotationList.f3, RubikRotationList.g3);
			e5c5.put(RubikRotationList.v3, RubikRotationList.b3);
			e5c5.put(RubikRotationList.r5, RubikRotationList.t5);
			e5c5.put(RubikRotationList.f5, RubikRotationList.g5);
			e5c5.put(RubikRotationList.v5, RubikRotationList.b5);
			e5c5.put(RubikRotationList.t3, RubikRotationList.v5);
			e5c5.put(RubikRotationList.g3, RubikRotationList.f5);
			e5c5.put(RubikRotationList.b3, RubikRotationList.r5);
			e5c5.put(RubikRotationList.t5, RubikRotationList.v3);
			e5c5.put(RubikRotationList.g5, RubikRotationList.f3);
			e5c5.put(RubikRotationList.b5, RubikRotationList.r3);
			
			return e5c5;
		}
		else {
			return e5c5;
		}
	}
	
	public static Map<Integer, Integer> gete3c3Map() {
		if(e3c3 == null) {
			
			e3c3 = new HashMap<Integer, Integer>();
			
			e3c3.put(RubikRotationList.e3, RubikRotationList.e3);
			e3c3.put(RubikRotationList.d3, RubikRotationList.d3);
			e3c3.put(RubikRotationList.c3, RubikRotationList.c3);
			e3c3.put(RubikRotationList.e5, RubikRotationList.e5);
			e3c3.put(RubikRotationList.d5, RubikRotationList.d5);
			e3c3.put(RubikRotationList.c5, RubikRotationList.c5);
			e3c3.put(RubikRotationList.r3, RubikRotationList.b5);
			e3c3.put(RubikRotationList.f3, RubikRotationList.g5);
			e3c3.put(RubikRotationList.v3, RubikRotationList.t5);
			e3c3.put(RubikRotationList.r5, RubikRotationList.b3);
			e3c3.put(RubikRotationList.f5, RubikRotationList.g3);
			e3c3.put(RubikRotationList.v5, RubikRotationList.t3);
			e3c3.put(RubikRotationList.t3, RubikRotationList.r3);
			e3c3.put(RubikRotationList.g3, RubikRotationList.f3);
			e3c3.put(RubikRotationList.b3, RubikRotationList.v3);
			e3c3.put(RubikRotationList.t5, RubikRotationList.r5);
			e3c3.put(RubikRotationList.g5, RubikRotationList.f5);
			e3c3.put(RubikRotationList.b5, RubikRotationList.v5);
			
			return e3c3;
		}
		else {
			return e3c3;
		}
	}
	
	public static Map<Integer, Integer> getr5v5Map() {
		if(r5v5 == null) {
			
			r5v5 = new HashMap<Integer, Integer>();
			
			r5v5.put(RubikRotationList.e3, RubikRotationList.b5);
			r5v5.put(RubikRotationList.d3, RubikRotationList.g5);
			r5v5.put(RubikRotationList.c3, RubikRotationList.t5);
			r5v5.put(RubikRotationList.e5, RubikRotationList.b3);
			r5v5.put(RubikRotationList.d5, RubikRotationList.g3);
			r5v5.put(RubikRotationList.c5, RubikRotationList.t3);
			r5v5.put(RubikRotationList.r3, RubikRotationList.r3);
			r5v5.put(RubikRotationList.f3, RubikRotationList.f3);
			r5v5.put(RubikRotationList.v3, RubikRotationList.v3);
			r5v5.put(RubikRotationList.r5, RubikRotationList.r5);
			r5v5.put(RubikRotationList.f5, RubikRotationList.f5);
			r5v5.put(RubikRotationList.v5, RubikRotationList.v5);
			r5v5.put(RubikRotationList.t3, RubikRotationList.e3);
			r5v5.put(RubikRotationList.g3, RubikRotationList.d3);
			r5v5.put(RubikRotationList.b3, RubikRotationList.c3);
			r5v5.put(RubikRotationList.t5, RubikRotationList.e5);
			r5v5.put(RubikRotationList.g5, RubikRotationList.d5);
			r5v5.put(RubikRotationList.b5, RubikRotationList.c5);
			
			return r5v5;
		}
		else {
			return r5v5;
		}
	}
	
	public static Map<Integer, Integer> getr3v3Map() {
		if(r3v3 == null) {
			
			r3v3 = new HashMap<Integer, Integer>();
			
			r3v3.put(RubikRotationList.e3, RubikRotationList.t3);
			r3v3.put(RubikRotationList.d3, RubikRotationList.g3);
			r3v3.put(RubikRotationList.c3, RubikRotationList.b3);
			r3v3.put(RubikRotationList.e5, RubikRotationList.t5);
			r3v3.put(RubikRotationList.d5, RubikRotationList.g5);
			r3v3.put(RubikRotationList.c5, RubikRotationList.b5);
			r3v3.put(RubikRotationList.r3, RubikRotationList.r3);
			r3v3.put(RubikRotationList.f3, RubikRotationList.f3);
			r3v3.put(RubikRotationList.v3, RubikRotationList.v3);
			r3v3.put(RubikRotationList.r5, RubikRotationList.r5);
			r3v3.put(RubikRotationList.f5, RubikRotationList.f5);
			r3v3.put(RubikRotationList.v5, RubikRotationList.v5);
			r3v3.put(RubikRotationList.t3, RubikRotationList.c5);
			r3v3.put(RubikRotationList.g3, RubikRotationList.d5);
			r3v3.put(RubikRotationList.b3, RubikRotationList.e5);
			r3v3.put(RubikRotationList.t5, RubikRotationList.c3);
			r3v3.put(RubikRotationList.g5, RubikRotationList.d3);
			r3v3.put(RubikRotationList.b5, RubikRotationList.e3);
			
			return r3v3;
		}
		else {
			return r3v3;
		}
	}
	
	public static Map<Integer, Integer> gett5b5Map() {
		if(t5b5 == null) {
			
			t5b5 = new HashMap<Integer, Integer>();
			
			t5b5.put(RubikRotationList.e3, RubikRotationList.r3);
			t5b5.put(RubikRotationList.d3, RubikRotationList.f3);
			t5b5.put(RubikRotationList.c3, RubikRotationList.v3);
			t5b5.put(RubikRotationList.e5, RubikRotationList.r5);
			t5b5.put(RubikRotationList.d5, RubikRotationList.f5);
			t5b5.put(RubikRotationList.c5, RubikRotationList.v5);
			t5b5.put(RubikRotationList.r3, RubikRotationList.c5);
			t5b5.put(RubikRotationList.f3, RubikRotationList.d5);
			t5b5.put(RubikRotationList.v3, RubikRotationList.e5);
			t5b5.put(RubikRotationList.r5, RubikRotationList.c3);
			t5b5.put(RubikRotationList.f5, RubikRotationList.d3);
			t5b5.put(RubikRotationList.v5, RubikRotationList.e3);
			t5b5.put(RubikRotationList.t3, RubikRotationList.t3);
			t5b5.put(RubikRotationList.g3, RubikRotationList.g3);
			t5b5.put(RubikRotationList.b3, RubikRotationList.b3);
			t5b5.put(RubikRotationList.t5, RubikRotationList.t5);
			t5b5.put(RubikRotationList.g5, RubikRotationList.g5);
			t5b5.put(RubikRotationList.b5, RubikRotationList.b5);
			
			return t5b5;
		}
		else {
			return t5b5;
		}
	}
	
	public static Map<Integer, Integer> gett3b3Map() {
		if(t3b3 == null) {
			
			t3b3 = new HashMap<Integer, Integer>();
			
			t3b3.put(RubikRotationList.e3, RubikRotationList.v5);
			t3b3.put(RubikRotationList.d3, RubikRotationList.f5);
			t3b3.put(RubikRotationList.c3, RubikRotationList.r5);
			t3b3.put(RubikRotationList.e5, RubikRotationList.v3);
			t3b3.put(RubikRotationList.d5, RubikRotationList.f3);
			t3b3.put(RubikRotationList.c5, RubikRotationList.r3);
			t3b3.put(RubikRotationList.r3, RubikRotationList.e3);
			t3b3.put(RubikRotationList.f3, RubikRotationList.d3);
			t3b3.put(RubikRotationList.v3, RubikRotationList.c3);
			t3b3.put(RubikRotationList.r5, RubikRotationList.e5);
			t3b3.put(RubikRotationList.f5, RubikRotationList.d5);
			t3b3.put(RubikRotationList.v5, RubikRotationList.c5);
			t3b3.put(RubikRotationList.t3, RubikRotationList.t3);
			t3b3.put(RubikRotationList.g3, RubikRotationList.g3);
			t3b3.put(RubikRotationList.b3, RubikRotationList.b3);
			t3b3.put(RubikRotationList.t5, RubikRotationList.t5);
			t3b3.put(RubikRotationList.g5, RubikRotationList.g5);
			t3b3.put(RubikRotationList.b5, RubikRotationList.b5);
			
			return t3b3;
		}
		else {
			return t3b3;
		}
	}
	
	

}
