/*******************************************************************************
 *    Rubik's Cube 3D game
 *     Copyright (C) 2011  Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com)
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 * 
 * 
 * Contributors:
 * Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com) - Core and UI development
 * Vishwajit Gaikwad (vishrockon7@gmail.com) - Testing
 ******************************************************************************/
package rubik.core;

import java.util.HashMap;
import java.util.Map;

public class RubikRotationMaps {
	
	static Map<Integer[], Integer[]> rotZN = null;
	static Map<Integer[], Integer[]> rotZP = null;
	static Map<Integer[], Integer[]> rotYP = null;
	static Map<Integer[], Integer[]> rotYN = null;
	static Map<Integer[], Integer[]> rotXP = null;
	static Map<Integer[], Integer[]> rotXN = null;
	
	public static Map<Integer[], Integer[]> getXNMap() {
		if(rotXN == null) {
			
			rotXN = new HashMap<Integer[], Integer[]>();
			
			rotXN.put(RubikCoordinates.c0_0_0, RubikCoordinates.c0_0_2);
			rotXN.put(RubikCoordinates.c0_0_1, RubikCoordinates.c0_1_2);
			rotXN.put(RubikCoordinates.c0_0_2, RubikCoordinates.c0_2_2);
			rotXN.put(RubikCoordinates.c0_1_0, RubikCoordinates.c0_0_1);
			rotXN.put(RubikCoordinates.c0_1_1, RubikCoordinates.c0_1_1);
			rotXN.put(RubikCoordinates.c0_1_2, RubikCoordinates.c0_2_1);
			rotXN.put(RubikCoordinates.c0_2_0, RubikCoordinates.c0_0_0);
			rotXN.put(RubikCoordinates.c0_2_1, RubikCoordinates.c0_1_0);
			rotXN.put(RubikCoordinates.c0_2_2, RubikCoordinates.c0_2_0);
			rotXN.put(RubikCoordinates.c1_0_0, RubikCoordinates.c1_0_2);
			rotXN.put(RubikCoordinates.c1_0_1, RubikCoordinates.c1_1_2);
			rotXN.put(RubikCoordinates.c1_0_2, RubikCoordinates.c1_2_2);
			rotXN.put(RubikCoordinates.c1_1_0, RubikCoordinates.c1_0_1);
			rotXN.put(RubikCoordinates.c1_1_2, RubikCoordinates.c1_2_1);
			rotXN.put(RubikCoordinates.c1_2_0, RubikCoordinates.c1_0_0);
			rotXN.put(RubikCoordinates.c1_2_1, RubikCoordinates.c1_1_0);
			rotXN.put(RubikCoordinates.c1_2_2, RubikCoordinates.c1_2_0);
			rotXN.put(RubikCoordinates.c2_0_0, RubikCoordinates.c2_0_2);
			rotXN.put(RubikCoordinates.c2_0_1, RubikCoordinates.c2_1_2);
			rotXN.put(RubikCoordinates.c2_0_2, RubikCoordinates.c2_2_2);
			rotXN.put(RubikCoordinates.c2_1_0, RubikCoordinates.c2_0_1);
			rotXN.put(RubikCoordinates.c2_1_1, RubikCoordinates.c2_1_1);
			rotXN.put(RubikCoordinates.c2_1_2, RubikCoordinates.c2_2_1);
			rotXN.put(RubikCoordinates.c2_2_0, RubikCoordinates.c2_0_0);
			rotXN.put(RubikCoordinates.c2_2_1, RubikCoordinates.c2_1_0);
			rotXN.put(RubikCoordinates.c2_2_2, RubikCoordinates.c2_2_0);
			
			return rotXN;
		}
		else {
			return rotXN;
		}
	}
	
	public static Map<Integer[], Integer[]> getXPMap() {
		if(rotXP == null) {
			
			rotXP = new HashMap<Integer[], Integer[]>();
			
			rotXP.put(RubikCoordinates.c0_0_0, RubikCoordinates.c0_2_0);
			rotXP.put(RubikCoordinates.c0_0_1, RubikCoordinates.c0_1_0);
			rotXP.put(RubikCoordinates.c0_0_2, RubikCoordinates.c0_0_0);
			rotXP.put(RubikCoordinates.c0_1_0, RubikCoordinates.c0_2_1);
			rotXP.put(RubikCoordinates.c0_1_1, RubikCoordinates.c0_1_1);
			rotXP.put(RubikCoordinates.c0_1_2, RubikCoordinates.c0_0_1);
			rotXP.put(RubikCoordinates.c0_2_0, RubikCoordinates.c0_2_2);
			rotXP.put(RubikCoordinates.c0_2_1, RubikCoordinates.c0_1_2);
			rotXP.put(RubikCoordinates.c0_2_2, RubikCoordinates.c0_0_2);
			rotXP.put(RubikCoordinates.c1_0_0, RubikCoordinates.c1_2_0);
			rotXP.put(RubikCoordinates.c1_0_1, RubikCoordinates.c1_1_0);
			rotXP.put(RubikCoordinates.c1_0_2, RubikCoordinates.c1_0_0);
			rotXP.put(RubikCoordinates.c1_1_0, RubikCoordinates.c1_2_1);
			rotXP.put(RubikCoordinates.c1_1_2, RubikCoordinates.c1_0_1);
			rotXP.put(RubikCoordinates.c1_2_0, RubikCoordinates.c1_2_2);
			rotXP.put(RubikCoordinates.c1_2_1, RubikCoordinates.c1_1_2);
			rotXP.put(RubikCoordinates.c1_2_2, RubikCoordinates.c1_0_2);
			rotXP.put(RubikCoordinates.c2_0_0, RubikCoordinates.c2_2_0);
			rotXP.put(RubikCoordinates.c2_0_1, RubikCoordinates.c2_1_0);
			rotXP.put(RubikCoordinates.c2_0_2, RubikCoordinates.c2_0_0);
			rotXP.put(RubikCoordinates.c2_1_0, RubikCoordinates.c2_2_1);
			rotXP.put(RubikCoordinates.c2_1_1, RubikCoordinates.c2_1_1);
			rotXP.put(RubikCoordinates.c2_1_2, RubikCoordinates.c2_0_1);
			rotXP.put(RubikCoordinates.c2_2_0, RubikCoordinates.c2_2_2);
			rotXP.put(RubikCoordinates.c2_2_1, RubikCoordinates.c2_1_2);
			rotXP.put(RubikCoordinates.c2_2_2, RubikCoordinates.c2_0_2);
			
			return rotXP;
		}
		else {
			return rotXP;
		}
	}
	
	public static Map<Integer[], Integer[]> getYNMap() {
		if(rotYN == null) {
			
			rotYN = new HashMap<Integer[], Integer[]>();
			
			rotYN.put(RubikCoordinates.c0_0_0, RubikCoordinates.c2_0_0);
			rotYN.put(RubikCoordinates.c0_0_1, RubikCoordinates.c1_0_0);
			rotYN.put(RubikCoordinates.c0_0_2, RubikCoordinates.c0_0_0);
			rotYN.put(RubikCoordinates.c0_1_0, RubikCoordinates.c2_1_0);
			rotYN.put(RubikCoordinates.c0_1_1, RubikCoordinates.c1_1_0);
			rotYN.put(RubikCoordinates.c0_1_2, RubikCoordinates.c0_1_0);
			rotYN.put(RubikCoordinates.c0_2_0, RubikCoordinates.c2_2_0);
			rotYN.put(RubikCoordinates.c0_2_1, RubikCoordinates.c1_2_0);
			rotYN.put(RubikCoordinates.c0_2_2, RubikCoordinates.c0_2_0);
			rotYN.put(RubikCoordinates.c1_0_0, RubikCoordinates.c2_0_1);
			rotYN.put(RubikCoordinates.c1_0_1, RubikCoordinates.c1_0_1);
			rotYN.put(RubikCoordinates.c1_0_2, RubikCoordinates.c0_0_1);
			rotYN.put(RubikCoordinates.c1_1_0, RubikCoordinates.c2_1_1);
			rotYN.put(RubikCoordinates.c1_1_2, RubikCoordinates.c0_1_1);
			rotYN.put(RubikCoordinates.c1_2_0, RubikCoordinates.c2_2_1);
			rotYN.put(RubikCoordinates.c1_2_1, RubikCoordinates.c1_2_1);
			rotYN.put(RubikCoordinates.c1_2_2, RubikCoordinates.c0_2_1);
			rotYN.put(RubikCoordinates.c2_0_0, RubikCoordinates.c2_0_2);
			rotYN.put(RubikCoordinates.c2_0_1, RubikCoordinates.c1_0_2);
			rotYN.put(RubikCoordinates.c2_0_2, RubikCoordinates.c0_0_2);
			rotYN.put(RubikCoordinates.c2_1_0, RubikCoordinates.c2_1_2);
			rotYN.put(RubikCoordinates.c2_1_1, RubikCoordinates.c1_1_2);
			rotYN.put(RubikCoordinates.c2_1_2, RubikCoordinates.c0_1_2);
			rotYN.put(RubikCoordinates.c2_2_0, RubikCoordinates.c2_2_2);
			rotYN.put(RubikCoordinates.c2_2_1, RubikCoordinates.c1_2_2);
			rotYN.put(RubikCoordinates.c2_2_2, RubikCoordinates.c0_2_2);
			
			return rotYN;
		}
		else {
			return rotYN;
		}
	}
	
	public static Map<Integer[], Integer[]> getYPMap() {
		if(rotYP == null) {
			
			rotYP = new HashMap<Integer[], Integer[]>();
			
			rotYP.put(RubikCoordinates.c0_0_0, RubikCoordinates.c0_0_2);
			rotYP.put(RubikCoordinates.c0_0_1, RubikCoordinates.c1_0_2);
			rotYP.put(RubikCoordinates.c0_0_2, RubikCoordinates.c2_0_2);
			rotYP.put(RubikCoordinates.c0_1_0, RubikCoordinates.c0_1_2);
			rotYP.put(RubikCoordinates.c0_1_1, RubikCoordinates.c1_1_2);
			rotYP.put(RubikCoordinates.c0_1_2, RubikCoordinates.c2_1_2);
			rotYP.put(RubikCoordinates.c0_2_0, RubikCoordinates.c0_2_2);
			rotYP.put(RubikCoordinates.c0_2_1, RubikCoordinates.c1_2_2);
			rotYP.put(RubikCoordinates.c0_2_2, RubikCoordinates.c2_2_2);
			rotYP.put(RubikCoordinates.c1_0_0, RubikCoordinates.c0_0_1);
			rotYP.put(RubikCoordinates.c1_0_1, RubikCoordinates.c1_0_1);
			rotYP.put(RubikCoordinates.c1_0_2, RubikCoordinates.c2_0_1);
			rotYP.put(RubikCoordinates.c1_1_0, RubikCoordinates.c0_1_1);
			rotYP.put(RubikCoordinates.c1_1_2, RubikCoordinates.c2_1_1);
			rotYP.put(RubikCoordinates.c1_2_0, RubikCoordinates.c0_2_1);
			rotYP.put(RubikCoordinates.c1_2_1, RubikCoordinates.c1_2_1);
			rotYP.put(RubikCoordinates.c1_2_2, RubikCoordinates.c2_2_1);
			rotYP.put(RubikCoordinates.c2_0_0, RubikCoordinates.c0_0_0);
			rotYP.put(RubikCoordinates.c2_0_1, RubikCoordinates.c1_0_0);
			rotYP.put(RubikCoordinates.c2_0_2, RubikCoordinates.c2_0_0);
			rotYP.put(RubikCoordinates.c2_1_0, RubikCoordinates.c0_1_0);
			rotYP.put(RubikCoordinates.c2_1_1, RubikCoordinates.c1_1_0);
			rotYP.put(RubikCoordinates.c2_1_2, RubikCoordinates.c2_1_0);
			rotYP.put(RubikCoordinates.c2_2_0, RubikCoordinates.c0_2_0);
			rotYP.put(RubikCoordinates.c2_2_1, RubikCoordinates.c1_2_0);
			rotYP.put(RubikCoordinates.c2_2_2, RubikCoordinates.c2_2_0);
			
			return rotYP;
		}
		else {
			return rotYP;
		}
	}
	
	public static Map<Integer[], Integer[]> getZNMap() {
		if(rotZN == null) {
			
			rotZN = new HashMap<Integer[], Integer[]>();
			
			rotZN.put(RubikCoordinates.c0_0_0, RubikCoordinates.c0_2_0);
			rotZN.put(RubikCoordinates.c0_0_1, RubikCoordinates.c0_2_1);
			rotZN.put(RubikCoordinates.c0_0_2, RubikCoordinates.c0_2_2);
			rotZN.put(RubikCoordinates.c0_1_0, RubikCoordinates.c1_2_0);
			rotZN.put(RubikCoordinates.c0_1_1, RubikCoordinates.c1_2_1);
			rotZN.put(RubikCoordinates.c0_1_2, RubikCoordinates.c1_2_2);
			rotZN.put(RubikCoordinates.c0_2_0, RubikCoordinates.c2_2_0);
			rotZN.put(RubikCoordinates.c0_2_1, RubikCoordinates.c2_2_1);
			rotZN.put(RubikCoordinates.c0_2_2, RubikCoordinates.c2_2_2);
			rotZN.put(RubikCoordinates.c1_0_0, RubikCoordinates.c0_1_0);
			rotZN.put(RubikCoordinates.c1_0_1, RubikCoordinates.c0_1_1);
			rotZN.put(RubikCoordinates.c1_0_2, RubikCoordinates.c0_1_2);
			rotZN.put(RubikCoordinates.c1_1_0, RubikCoordinates.c1_1_0);
			rotZN.put(RubikCoordinates.c1_1_2, RubikCoordinates.c1_1_2);
			rotZN.put(RubikCoordinates.c1_2_0, RubikCoordinates.c2_1_0);
			rotZN.put(RubikCoordinates.c1_2_1, RubikCoordinates.c2_1_1);
			rotZN.put(RubikCoordinates.c1_2_2, RubikCoordinates.c2_1_2);
			rotZN.put(RubikCoordinates.c2_0_0, RubikCoordinates.c0_0_0);
			rotZN.put(RubikCoordinates.c2_0_1, RubikCoordinates.c0_0_1);
			rotZN.put(RubikCoordinates.c2_0_2, RubikCoordinates.c0_0_2);
			rotZN.put(RubikCoordinates.c2_1_0, RubikCoordinates.c1_0_0);
			rotZN.put(RubikCoordinates.c2_1_1, RubikCoordinates.c1_0_1);
			rotZN.put(RubikCoordinates.c2_1_2, RubikCoordinates.c1_0_2);
			rotZN.put(RubikCoordinates.c2_2_0, RubikCoordinates.c2_0_0);
			rotZN.put(RubikCoordinates.c2_2_1, RubikCoordinates.c2_0_1);
			rotZN.put(RubikCoordinates.c2_2_2, RubikCoordinates.c2_0_2);
			
			return rotZN;
		}
		else {
			return rotZN;
		}
	}
	
	public static Map<Integer[], Integer[]> getZPMap() {
		if(rotZP == null) {
			
			rotZP = new HashMap<Integer[], Integer[]>();
			
			rotZP.put(RubikCoordinates.c0_0_0, RubikCoordinates.c2_0_0);
			rotZP.put(RubikCoordinates.c0_0_1, RubikCoordinates.c2_0_1);
			rotZP.put(RubikCoordinates.c0_0_2, RubikCoordinates.c2_0_2);
			rotZP.put(RubikCoordinates.c0_1_0, RubikCoordinates.c1_0_0);
			rotZP.put(RubikCoordinates.c0_1_1, RubikCoordinates.c1_0_1);
			rotZP.put(RubikCoordinates.c0_1_2, RubikCoordinates.c1_0_2);
			rotZP.put(RubikCoordinates.c0_2_0, RubikCoordinates.c0_0_0);
			rotZP.put(RubikCoordinates.c0_2_1, RubikCoordinates.c0_0_1);
			rotZP.put(RubikCoordinates.c0_2_2, RubikCoordinates.c0_0_2);
			rotZP.put(RubikCoordinates.c1_0_0, RubikCoordinates.c2_1_0);
			rotZP.put(RubikCoordinates.c1_0_1, RubikCoordinates.c2_1_1);
			rotZP.put(RubikCoordinates.c1_0_2, RubikCoordinates.c2_1_2);
			rotZP.put(RubikCoordinates.c1_1_0, RubikCoordinates.c1_1_0);
			rotZP.put(RubikCoordinates.c1_1_2, RubikCoordinates.c1_1_2);
			rotZP.put(RubikCoordinates.c1_2_0, RubikCoordinates.c0_1_0);
			rotZP.put(RubikCoordinates.c1_2_1, RubikCoordinates.c0_1_1);
			rotZP.put(RubikCoordinates.c1_2_2, RubikCoordinates.c0_1_2);
			rotZP.put(RubikCoordinates.c2_0_0, RubikCoordinates.c2_2_0);
			rotZP.put(RubikCoordinates.c2_0_1, RubikCoordinates.c2_2_1);
			rotZP.put(RubikCoordinates.c2_0_2, RubikCoordinates.c2_2_2);
			rotZP.put(RubikCoordinates.c2_1_0, RubikCoordinates.c1_2_0);
			rotZP.put(RubikCoordinates.c2_1_1, RubikCoordinates.c1_2_1);
			rotZP.put(RubikCoordinates.c2_1_2, RubikCoordinates.c1_2_2);
			rotZP.put(RubikCoordinates.c2_2_0, RubikCoordinates.c0_2_0);
			rotZP.put(RubikCoordinates.c2_2_1, RubikCoordinates.c0_2_1);
			rotZP.put(RubikCoordinates.c2_2_2, RubikCoordinates.c0_2_2);
			
			return rotZP;
		}
		else {
			return rotZP;
		}
	}

}
