/*******************************************************************************
 *    Rubik's Cube 3D game
 *     Copyright (C) 2011  Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com)
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 * 
 * 
 * Contributors:
 * Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com) - Core and UI development
 * Vishwajit Gaikwad (vishrockon7@gmail.com) - Testing
 ******************************************************************************/
package rubik.ui;

import java.awt.Font;
import java.util.ArrayList;
import java.util.List;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Font3D;
import javax.media.j3d.FontExtrusion;
import javax.media.j3d.Shape3D;
import javax.media.j3d.Text3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Vector3d;

import com.sun.j3d.utils.behaviors.mouse.MouseBehaviorCallback;

public class RubikControlsUI {
	
	MouseBehaviorCallback mouseCallback = new MouseBehaviorCallback() {
		
		@Override
		public void transformChanged(int type, Transform3D transform) {			
			
			for(int i=0; i < all_vecs.size(); i++) {
				
				transform.transform(all_vecs.get(i), all_vecs_transformed.get(i));
				
			}
			
			getTextPosition();
			
			Transform3D temp = new Transform3D();
			temp.set(current_ctrl_e);
			temp.setScale(0.06d);
			text_eTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_d);
			temp.setScale(0.06d);
			text_dTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_c);
			temp.setScale(0.06d);
			text_cTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_r);
			temp.setScale(0.06d);
			text_rTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_f);
			temp.setScale(0.06d);
			text_fTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_v);
			temp.setScale(0.06d);
			text_vTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_t);
			temp.setScale(0.06d);
			text_tTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_g);
			temp.setScale(0.06d);
			text_gTG.setTransform(temp);
			
			temp = new Transform3D();
			temp.set(current_ctrl_b);
			temp.setScale(0.06d);
			text_bTG.setTransform(temp);
			
			if(arrow != null) {
				arrow.updateArrow(transform);
			}
			
			if(axis != null) {
				axis.updateAxisRotateTG(transform);
			}
			
		}
		
	};
	
	List<Vector3d> ctrl_e = null;
	List<Vector3d> ctrl_d = null;
	List<Vector3d> ctrl_c = null;
	
	List<Vector3d> ctrl_r = null;
	List<Vector3d> ctrl_f = null;
	List<Vector3d> ctrl_v = null;
	
	List<Vector3d> ctrl_t = null;
	List<Vector3d> ctrl_g = null;
	List<Vector3d> ctrl_b = null;
	
	List<Vector3d> ctrl_e_transformed = null;
	List<Vector3d> ctrl_d_transformed = null;
	List<Vector3d> ctrl_c_transformed = null;
	
	List<Vector3d> ctrl_r_transformed = null;
	List<Vector3d> ctrl_f_transformed = null;
	List<Vector3d> ctrl_v_transformed = null;
	
	List<Vector3d> ctrl_t_transformed = null;
	List<Vector3d> ctrl_g_transformed = null;
	List<Vector3d> ctrl_b_transformed = null;
	
	List<Vector3d> all_vecs = null;
	
	List<Vector3d> all_vecs_transformed = null;
	
	Vector3d current_ctrl_e = null;
	Vector3d current_ctrl_d = null;
	Vector3d current_ctrl_c = null;
	
	Vector3d current_ctrl_r = null;
	Vector3d current_ctrl_f = null;
	Vector3d current_ctrl_v = null;
	
	Vector3d current_ctrl_t = null;
	Vector3d current_ctrl_g = null;
	Vector3d current_ctrl_b = null;
	
	TransformGroup text_eTG = null;
	TransformGroup text_dTG = null;
	TransformGroup text_cTG = null;
	
	TransformGroup text_rTG = null;
	TransformGroup text_fTG = null;
	TransformGroup text_vTG = null;
	
	TransformGroup text_tTG = null;
	TransformGroup text_gTG = null;
	TransformGroup text_bTG = null;
	
	RubikControlsUIArrow arrow = null;
	
	RubikAxis axis = null;
	
	public RubikControlsUI(BranchGroup root) {
		
		ctrl_e = new ArrayList<Vector3d>();
		ctrl_d = new ArrayList<Vector3d>();
		ctrl_c = new ArrayList<Vector3d>();
		
		ctrl_r = new ArrayList<Vector3d>();
		ctrl_f = new ArrayList<Vector3d>();
		ctrl_v = new ArrayList<Vector3d>();
		
		ctrl_t = new ArrayList<Vector3d>();
		ctrl_g = new ArrayList<Vector3d>();
		ctrl_b = new ArrayList<Vector3d>();
		
		ctrl_e_transformed = new ArrayList<Vector3d>();
		ctrl_d_transformed = new ArrayList<Vector3d>();
		ctrl_c_transformed = new ArrayList<Vector3d>();
		
		ctrl_r_transformed = new ArrayList<Vector3d>();
		ctrl_f_transformed = new ArrayList<Vector3d>();
		ctrl_v_transformed = new ArrayList<Vector3d>();
		
		ctrl_t_transformed = new ArrayList<Vector3d>();
		ctrl_g_transformed = new ArrayList<Vector3d>();
		ctrl_b_transformed = new ArrayList<Vector3d>();
		
		all_vecs = new ArrayList<Vector3d>();
		
		all_vecs_transformed = new ArrayList<Vector3d>();
		
		ctrl_e.add(new Vector3d(0.35d, 0.35d, 0.2d));
		ctrl_e.add(new Vector3d(-0.35d, 0.35d, 0.2d));
		ctrl_e.add(new Vector3d(-0.35d, -0.35d, 0.2d));
		ctrl_e.add(new Vector3d(0.35d, -0.35d, 0.2d));
		
		ctrl_e_transformed.add(new Vector3d(0.35d, 0.35d, 0.2d));
		ctrl_e_transformed.add(new Vector3d(-0.35d, 0.35d, 0.2d));
		ctrl_e_transformed.add(new Vector3d(-0.35d, -0.35d, 0.2d));
		ctrl_e_transformed.add(new Vector3d(0.35d, -0.35d, 0.2d));
		
		all_vecs.addAll(ctrl_e);
		
		all_vecs_transformed.addAll(ctrl_e_transformed);
		
		ctrl_d.add(new Vector3d(0.35d, 0.35d, 0d));
		ctrl_d.add(new Vector3d(-0.35d, 0.35d, 0d));
		ctrl_d.add(new Vector3d(-0.35d, -0.35d, 0d));
		ctrl_d.add(new Vector3d(0.35d, -0.35d, 0d));
		
		ctrl_d_transformed.add(new Vector3d(0.35d, 0.35d, 0d));
		ctrl_d_transformed.add(new Vector3d(-0.35d, 0.35d, 0d));
		ctrl_d_transformed.add(new Vector3d(-0.35d, -0.35d, 0d));
		ctrl_d_transformed.add(new Vector3d(0.35d, -0.35d, 0d));
		
		all_vecs.addAll(ctrl_d);
		
		all_vecs_transformed.addAll(ctrl_d_transformed);
		
		ctrl_c.add(new Vector3d(0.35d, 0.35d, -0.2d));
		ctrl_c.add(new Vector3d(-0.35d, 0.35d, -0.2d));
		ctrl_c.add(new Vector3d(-0.35d, -0.35d, -0.2d));
		ctrl_c.add(new Vector3d(0.35d, -0.35d, -0.2d));
		
		ctrl_c_transformed.add(new Vector3d(0.35d, 0.35d, -0.2d));
		ctrl_c_transformed.add(new Vector3d(-0.35d, 0.35d, -0.2d));
		ctrl_c_transformed.add(new Vector3d(-0.35d, -0.35d, -0.2d));
		ctrl_c_transformed.add(new Vector3d(0.35d, -0.35d, -0.2d));
		
		all_vecs.addAll(ctrl_c);
		
		all_vecs_transformed.addAll(ctrl_c_transformed);
		
		ctrl_r.add(new Vector3d(0.2d, 0.35d, 0.35d));
		ctrl_r.add(new Vector3d(0.2d, -0.35d, 0.35d));
		ctrl_r.add(new Vector3d(0.2d, -0.35d, -0.35d));
		ctrl_r.add(new Vector3d(0.2d, 0.35d, -0.35d));
		
		ctrl_r_transformed.add(new Vector3d(0.2d, 0.35d, 0.35d));
		ctrl_r_transformed.add(new Vector3d(0.2d, -0.35d, 0.35d));
		ctrl_r_transformed.add(new Vector3d(0.2d, -0.35d, -0.35d));
		ctrl_r_transformed.add(new Vector3d(0.2d, 0.35d, -0.35d));
		
		all_vecs.addAll(ctrl_r);
		
		all_vecs_transformed.addAll(ctrl_r_transformed);
		
		ctrl_f.add(new Vector3d(0d, 0.35d, 0.35d));
		ctrl_f.add(new Vector3d(0d, -0.35d, 0.35d));
		ctrl_f.add(new Vector3d(0d, -0.35d, -0.35d));
		ctrl_f.add(new Vector3d(0d, 0.35d, -0.35d));
		
		ctrl_f_transformed.add(new Vector3d(0d, 0.35d, 0.35d));
		ctrl_f_transformed.add(new Vector3d(0d, -0.35d, 0.35d));
		ctrl_f_transformed.add(new Vector3d(0d, -0.35d, -0.35d));
		ctrl_f_transformed.add(new Vector3d(0d, 0.35d, -0.35d));
		
		all_vecs.addAll(ctrl_f);
		
		all_vecs_transformed.addAll(ctrl_f_transformed);
		
		ctrl_v.add(new Vector3d(-0.2d, 0.35d, 0.35d));
		ctrl_v.add(new Vector3d(-0.2d, -0.35d, 0.35d));
		ctrl_v.add(new Vector3d(-0.2d, -0.35d, -0.35d));
		ctrl_v.add(new Vector3d(-0.2d, 0.35d, -0.35d));
		
		ctrl_v_transformed.add(new Vector3d(-0.2d, 0.35d, 0.35d));
		ctrl_v_transformed.add(new Vector3d(-0.2d, -0.35d, 0.35d));
		ctrl_v_transformed.add(new Vector3d(-0.2d, -0.35d, -0.35d));
		ctrl_v_transformed.add(new Vector3d(-0.2d, 0.35d, -0.35d));
		
		all_vecs.addAll(ctrl_v);
		
		all_vecs_transformed.addAll(ctrl_v_transformed);
		
		ctrl_t.add(new Vector3d(0.35d, 0.2d, 0.35d));
		ctrl_t.add(new Vector3d(-0.35d, 0.2d, 0.35d));
		ctrl_t.add(new Vector3d(-0.35d, 0.2d, -0.35d));
		ctrl_t.add(new Vector3d(0.35d, 0.2d, -0.35d));
		
		ctrl_t_transformed.add(new Vector3d(0.35d, 0.2d, 0.35d));
		ctrl_t_transformed.add(new Vector3d(-0.35d, 0.2d, 0.35d));
		ctrl_t_transformed.add(new Vector3d(-0.35d, 0.2d, -0.35d));
		ctrl_t_transformed.add(new Vector3d(0.35d, 0.2d, -0.35d));
		
		all_vecs.addAll(ctrl_t);
		
		all_vecs_transformed.addAll(ctrl_t_transformed);
		
		ctrl_g.add(new Vector3d(0.35d, 0d, 0.35d));
		ctrl_g.add(new Vector3d(-0.35d, 0d, 0.35d));
		ctrl_g.add(new Vector3d(-0.35d, 0d, -0.35d));
		ctrl_g.add(new Vector3d(0.35d, 0d, -0.35d));
		
		ctrl_g_transformed.add(new Vector3d(0.35d, 0d, 0.35d));
		ctrl_g_transformed.add(new Vector3d(-0.35d, 0d, 0.35d));
		ctrl_g_transformed.add(new Vector3d(-0.35d, 0d, -0.35d));
		ctrl_g_transformed.add(new Vector3d(0.35d, 0d, -0.35d));
		
		all_vecs.addAll(ctrl_g);
		
		all_vecs_transformed.addAll(ctrl_g_transformed);
		
		ctrl_b.add(new Vector3d(0.35d, -0.2d, 0.35d));
		ctrl_b.add(new Vector3d(-0.35d, -0.2d, 0.35d));
		ctrl_b.add(new Vector3d(-0.35d, -0.2d, -0.35d));
		ctrl_b.add(new Vector3d(0.35d, -0.2d, -0.35d));
		
		ctrl_b_transformed.add(new Vector3d(0.35d, -0.2d, 0.35d));
		ctrl_b_transformed.add(new Vector3d(-0.35d, -0.2d, 0.35d));
		ctrl_b_transformed.add(new Vector3d(-0.35d, -0.2d, -0.35d));
		ctrl_b_transformed.add(new Vector3d(0.35d, -0.2d, -0.35d));
		
		all_vecs.addAll(ctrl_b);
		
		all_vecs_transformed.addAll(ctrl_b_transformed);
		
		text_eTG = new TransformGroup();
		text_eTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_dTG = new TransformGroup();
		text_dTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_cTG = new TransformGroup();
		text_cTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		
		text_rTG = new TransformGroup();
		text_rTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_fTG = new TransformGroup();
		text_fTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_vTG = new TransformGroup();
		text_vTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		
		text_tTG = new TransformGroup();
		text_tTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_gTG = new TransformGroup();
		text_gTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		text_bTG = new TransformGroup();
		text_bTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		
		createTextNodes();
		getTextPosition();
		
		Transform3D temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_e.getX(), current_ctrl_e.getY(), 0d));
		temp.setScale(0.06d);
		text_eTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_d.getX(), current_ctrl_d.getY(), 0d));
		temp.setScale(0.06d);
		text_dTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_c.getX(), current_ctrl_c.getY(), 0d));
		temp.setScale(0.06d);
		text_cTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_r.getX(), current_ctrl_r.getY(), 0d));
		temp.setScale(0.06d);
		text_rTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_f.getX(), current_ctrl_f.getY(), 0d));
		temp.setScale(0.06d);
		text_fTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_v.getX(), current_ctrl_v.getY(), 0d));
		temp.setScale(0.06d);
		text_vTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_t.getX(), current_ctrl_t.getY(), 0d));
		temp.setScale(0.06d);
		text_tTG.setTransform(temp);
		
		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_g.getX(), current_ctrl_g.getY(), 0d));
		temp.setScale(0.06d);
		text_gTG.setTransform(temp);

		temp = new Transform3D();
		temp.set(new Vector3d(current_ctrl_b.getX(), current_ctrl_b.getY(), 0d));
		temp.setScale(0.06d);
		text_bTG.setTransform(temp);
		
		root.addChild(text_eTG);
		root.addChild(text_dTG);
		root.addChild(text_cTG);
		
		root.addChild(text_rTG);
		root.addChild(text_fTG);
		root.addChild(text_vTG);
		
		root.addChild(text_tTG);
		root.addChild(text_gTG);
		root.addChild(text_bTG);
		
	}
	
	public void setArrowObject(RubikControlsUIArrow arrowObject) {
		
		this.arrow = arrowObject;
		
	}
	
	public void setAxisObject(RubikAxis axisObject) {
		
		this.axis = axisObject;
		
	}
	
	public MouseBehaviorCallback getCallbackClass() {
		return mouseCallback;
	}
	
	void getTextPosition() {
		
		int pos = -1;
		
		pos = min(ctrl_d_transformed);
		current_ctrl_e = ctrl_e_transformed.get(pos);
		current_ctrl_d = ctrl_d_transformed.get(pos);
		current_ctrl_c = ctrl_c_transformed.get(pos);
		
		pos = min(ctrl_f_transformed);
		current_ctrl_r = ctrl_r_transformed.get(pos);
		current_ctrl_f = ctrl_f_transformed.get(pos);
		current_ctrl_v = ctrl_v_transformed.get(pos);
		
		pos = min(ctrl_g_transformed);
		current_ctrl_t = ctrl_t_transformed.get(pos);
		current_ctrl_g = ctrl_g_transformed.get(pos);
		current_ctrl_b = ctrl_b_transformed.get(pos);
		
	}
	
	int min(List<Vector3d> toSort) {
		
		double[] d = { toSort.get(0).getX() * toSort.get(0).getX() +
				toSort.get(0).getY() * toSort.get(0).getY(), 
				toSort.get(1).getX() * toSort.get(1).getX() +
				toSort.get(1).getY() * toSort.get(1).getY(), 
				toSort.get(2).getX() * toSort.get(2).getX() +
				toSort.get(2).getY() * toSort.get(2).getY(), 
				toSort.get(3).getX() * toSort.get(3).getX() +
				toSort.get(3).getY() * toSort.get(3).getY() };
		
		if(d[0] >= d[1] && d[0] >= d[2] && d[0] >= d[3]) {
			return 0;
		}
		else if(d[1] >= d[0] && d[1] >= d[2] && d[1] >= d[3]) {
			return 1;
		}
		else if(d[2] >= d[1] && d[2] >= d[0] && d[2] >= d[3]) {
			return 2;
		}
		return 3;


	}
	
	void createTextNodes() {
		
        Font3D font = new Font3D(new Font("Helvetica", Font.PLAIN, 1),
                new FontExtrusion());
        
        Text3D textGeom = null;
        Shape3D textShape = null;
		
        textGeom = new Text3D(font, new String("e"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_eTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("d"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_dTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("c"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_cTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("r"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_rTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("f"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_fTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("v"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_vTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("t"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_tTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("g"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_gTG.addChild(textShape);
        
        textGeom = new Text3D(font, new String("b"));
        textGeom.setAlignment(Text3D.ALIGN_CENTER);
        textShape = new Shape3D();
        textShape.setGeometry(textGeom);
        text_bTG.addChild(textShape);
        
	}
	

}
