/*******************************************************************************
 *    Rubik's Cube 3D game
 *     Copyright (C) 2011  Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com)
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 * 
 * 
 * Contributors:
 * Harshad Sahasrabudhe (harshad.sahasrabudhe@gmail.com) - Core and UI development
 * Vishwajit Gaikwad (vishrockon7@gmail.com) - Testing
 ******************************************************************************/
package rubik.ui;

import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.TransformGroup;

import com.sun.j3d.utils.behaviors.mouse.MouseBehaviorCallback;
import com.sun.j3d.utils.behaviors.mouse.MouseRotate;

public class RubikMouseRotate {
	
	MouseRotate myMouseRotate = null;
	TransformGroup mouseRotateTG = null;
	
	public RubikMouseRotate(BranchGroup root, BranchGroup sceneroot) {
		
		mouseRotateTG = new TransformGroup();
		mouseRotateTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		mouseRotateTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		myMouseRotate = new MouseRotate();
		myMouseRotate.setTransformGroup(mouseRotateTG);
		myMouseRotate.setSchedulingBounds(new BoundingSphere());
		root.addChild(mouseRotateTG);
		root.addChild(myMouseRotate);
		
		mouseRotateTG.addChild(sceneroot);
	}
	
	public void setCallBack(MouseBehaviorCallback callbackClass) {
		
		myMouseRotate.setupCallback(callbackClass);
		
	}
}
